SUMO
Simulation of Urban MObility

- Home
- Download
- Documentation
- Wiki
- Trac
- Blog
- Contact
- SF-Project

# NETGENERATE

# From 30.000 feet

NETGENERATE generates abstract road networks that may be used by other SUMO-applications.

  Purpose: Abstract road network generation
  System: portable (Linux/Windows is tested); runs on command line
  Input (mandatory): Command line parameter
  Output: A generated SUMO-road network; optionally also other outputs
  Programming Language: c++

# Usage Description

## Options

You may use a XML schema definition file for setting up a NETGENERATE configuration: netgenerateConfiguration.xsd.

### Configuration

All applications of the SUMO-suite handle configuration options the same way. These options are discussed at Basics/Using the Command Line Applications#Configuration Files.

Option | Description
--- | ---
-c <FILE> --configuration-file <FILE> | Loads the named config on startup
--save-configuration <FILE> | Saves current configuration into FILE
--save-template <FILE> | Saves a configuration template (empty) into FILE
--save-schema <FILE> | Saves the configuration schema into FILE
--save-commented | Adds comments to saved template, configuration, or schema; default: false

### Grid Network

Option | Description
--- | ---
-g --grid | Forces NETGENERATE to build a grid-like network; default: false
--grid.number <INT> | The number of junctions in both dirs; default: 5
--grid.length <FLOAT> | The length of streets in both dirs; default: 100
--grid.x-number <INT> | The number of junctions in x-dir; Overrides --grid-number; default: 5
--grid.y-number <INT> | The number of junctions in y-dir; Overrides --grid-number; default: 5
--grid.x-length <FLOAT> | The length of horizontal streets; Overrides --grid-length; default: 100
--grid.y-length <FLOAT> | The length of vertical streets; Overrides --grid-length; default: 100
--grid.attach-length <FLOAT> | The length of streets attached at the boundary; 0 means no streets are attached; default: 0

### Spider Network

Option | Description
--- | ---
-s --spider | Forces NETGENERATE to build a spider-net-like network; default: false
--spider.arm-number <INT> | The number of axes within the net; default: 13
--spider.circle-number <INT> | The number of circles of the net; default: 20
--spider.space-radius <FLOAT> | The distances between the circles; default: 100
--spider.omit-center | Omit the central node of the network; default: false

### Random Network

Option | Description
--- | ---
-r --rand | Forces NETGENERATE to build a random network; default: false
--rand.iterations <INT> | Describes how many times an edge shall be added to the net; default: 2000
--rand.bidi-probability <FLOAT> | Defines the probability to build a reverse edge; default: 1
--rand.max-distance <FLOAT> | default: 250
--rand.min-distance <FLOAT> | default: 100
--rand.min-angle <FLOAT> | default: 0.785398
--rand.num-tries <INT> | ; default: 50
--rand.connectivity <FLOAT> | default: 0.95
--rand.neighbor-dist1 <FLOAT> | default: 0
--rand.neighbor-dist2 <FLOAT> | default: 0
--rand.neighbor-dist3 <FLOAT> | default: 10
--rand.neighbor-dist4 <FLOAT> | default: 10
--rand.neighbor-dist5 <FLOAT> | default: 2
--rand.neighbor-dist6 <FLOAT> | default: 1

### Output

Option | Description
--- | ---
-o <FILE> --output-file <FILE> | The generated net will be written to FILE
--plain-output-prefix <FILE> | Prefix of files to write plain xml nodes, edges and connections to
-M <FILE> --map-output <FILE> | Writes joined edges information to FILE
--matsim-output <FILE> | The generated net will be written to FILE using MATSIM format.
--output.street-names | Street names will be included in the output (if available); default: false

### TLS Building

Option | Description
--- | ---
--tls.set <STRING> | Interprets STR as list of junctions to be controlled by TLS
--tls.unset <STRING> | Interprets STR as list of junctions to be not controlled by TLS
--tls.guess | Turns on TLS guessing; default: false
--tls-guess.joining | Includes node clusters into guess; default: false
--tls.join | Tries to cluster tls-controlled nodes; default: false
--tls.green.time <INT> | Use INT as green phase duration; default: 31
-D <FLOAT> --tls.yellow.min-decel <FLOAT> | Defines smallest vehicle deceleration; default: 3
--tls.yellow.patch-small | Given yellow times are patched even if being too short; default: false
--tls.yellow.time <INT> | Set INT as fixed time for yellow phase durations
--tls.half-offset <STRING> | TLSs in STR will be shifted by half-phase
--tls.quarter-offset <STRING> | TLSs in STR will be shifted by quarter-phase

### Edge Removal

Option | Description
--- | ---
--keep-edges.min-speed <FLOAT> | Remove edges with speed < FLOAT
--remove-edges.explicit <STRING> | Remove edges in STR, seperated by semicolon
--keep-edges.explicit <STRING> | Remove edges not in STR, seperated by semicolon
--keep-edges.input-file <FILE> | Removed edges not in FILE
--keep-edges.in-boundary <STRING> | Keeps edges which are located within the given boundary

### Unregulated Nodes

Option | Description
--- | ---
--keep-nodes-unregulated | All nodes will be not regulated; default: false
--keep-nodes-unregulated.explicit <STRING> | Do not regulate nodes in STR
--keep-nodes-unregulated.district-nodes | Do not regulate district nodes; default: false

### Processing

Normally, both NETCONVERT and NETGENERATE translate the read network so that the left- and down-most node are at coordinate (0,0). The following options allow to disable this and to apply different offsets for both the x- and the y-axis. If there are explicit offsets given, the normalization is disabled automatically (thus there is no need to give --disable-normalize-node-positions if there is at least one of the offsets given).

Option | Description
--- | ---
--no-internal-links | Omits internal links; default: false
--no-turnarounds | Disables building turnarounds; default: false
--no-turnarounds.tls | Disables building turnarounds at tls-controlled junctions; default: false
--offset.disable-normalization | Turn off normalizing node positions; default: false
--offset.x <FLOAT> | Adds FLOAT to net x-positions; default: 0
--offset.y <FLOAT> | Adds FLOAT to net y-positions; default: 0
--flip-y-axis | Flips the y-coordinate along zero; default: false
--roundabouts.guess | Enable roundabout-guessing; default: false
--lefthand | Assumes left-hand traffic on the network; default: false
--junctions.join | Joins junctions that are close to each other (recommended for OSM import); default: false
--junctions.join-dist <FLOAT> | Determines the maximal distance for joining junctions; default: 15

### Building Defaults

Option | Description
--- | ---
-L <INT> --default.lanenumber <INT> | The default number of lanes in an edge; default: 1
-S <FLOAT> --default.speed <FLOAT> | The default speed on an edge (in m/s); default: 13.9
-P <INT> --default.priority <INT> | The default priority of an edge; default: -1
-j <STRING> --default-junction-type <STRING> | [traffic_light|priority|right_before_left] Determines the type of the build junctions

### Report

All applications of the SUMO-suite handle most of the reporting options the same way. These options are discussed at Basics/Using the Command Line Applications#Reporting Options.

Option | Description
--- | ---
-v --verbose | Switches to verbose output; default: false
-p --print-options | Prints option values before processing; default: false
-? --help | Prints this screen; default: false
-V --version | Prints the current version; default: false
-W --no-warnings | Disables output of warnings; default: false
-l <FILE> --log <FILE> | Writes all messages to FILE
--message-log <FILE> | Writes all non-error messages to FILE
--error-log <FILE> | Writes all warnings and errors to FILE

### Random Number

All applications of the SUMO-suite handle randomisation options the same way. These options are discussed at Basics/Using the Command Line Applications#Random Number Options.

Option | Description
--- | ---
--random | Initialises the random number generator with the current system time; default: false
--seed <INT> | Initialises the random number generator with the given value; default: 23423

This page was last modified on 28 June 2012, at 08:01.